unit ProtonMacGen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, StrUtils, Registry, MacroCodeGenerator,
  StdActns, BrwsFldr, IDE_Info, cPluginInterface, cPluginTypes, cPluginMessages,
  Confirm, MacSourceReadWrite, HintPopUp;

type

  TfmMacroGen = class(TForm)
    pnlStep0: TPanel;
    pnlNav: TPanel;
    cmdNavHelp: TButton;
    cmdNavCancel: TButton;
    cmdNavBack: TButton;
    cmdNavNext: TButton;
    cmdNavFinished: TButton;
    pnlStep1: TPanel;
    lblStep1: TLabel;
    Panel3: TPanel;
    Image2: TImage;
    pnlStep2: TPanel;
    lblStep2: TLabel;
    Panel5: TPanel;
    Image3: TImage;
    pnlParamNum: TPanel;
    pnlStep3: TPanel;
    lblStep3: TLabel;
    Panel4: TPanel;
    Image4: TImage;
    cmdReload: TButton;
    txtMacroName: TEdit;
    cboReturn: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    memoDescription: TMemo;
    chkTypeConvOn: TCheckBox;
    OptTgt14: TRadioButton;
    optTgt16: TRadioButton;
    optTgtBoth: TRadioButton;
    chkNoCode: TCheckBox;
    Label3: TLabel;
    txtParamName: TEdit;
    cmbArgDataType: TComboBox;
    cmdRemArg: TButton;
    cmdPrevArg: TButton;
    cmdNextArg: TButton;
    cmdAddArg: TButton;
    chkArgOptional: TCheckBox;
    chkAllowAltArgs: TCheckBox;
    Label4: TLabel;
    Label6: TLabel;
    pnlSubRoutineName: TPanel;
    cmbSubroutineName: TComboBox;
    cmdShowLabels: TButton;
    optCallSub: TRadioButton;
    optJumpSub: TRadioButton;
    Label7: TLabel;
    pnlReturnVar: TPanel;
    cmbRetVarName: TComboBox;
    cmbRetDataType: TComboBox;
    chkRetOptional: TCheckBox;
    Label8: TLabel;
    Label9: TLabel;
    cmdGetVars1: TButton;
    chkAllowAltRet: TCheckBox;
    pnlStep5: TPanel;
    lblStep5b: TLabel;
    memoHint: TMemo;
    pnlStep4: TPanel;
    lblStep4: TLabel;
    pnlStep6: TPanel;
    lblStep6: TLabel;
    Panel7: TPanel;
    Image5: TImage;
    Bevel1: TBevel;
    lblStep0: TLabel;
    pnlStat: TPanel;
    chkShowIntro: TCheckBox;
    Panel2: TPanel;
    Image1: TImage;
    pnlDestVar: TPanel;
    Label5: TLabel;
    cmbDestVarName: TComboBox;
    cmdGetVars0: TButton;
    lblParamNums: TLabel;
    OpenDialog1: TOpenDialog;
    BrowseForFolder1: TBrowseForFolder;
    Panel1: TPanel;
    chkPasteCode: TCheckBox;
    chkSaveCode: TCheckBox;
    chkSaveHint: TCheckBox;
    chkSaveSource: TCheckBox;
    txtSavePath: TEdit;
    Label10: TLabel;
    cmdBrowseSavePath: TButton;
    lblSaveCodeName: TLabel;
    lblSaveHintName: TLabel;
    lblSaveSourceName: TLabel;
    lblPasteDest: TLabel;
    Panel6: TPanel;
    rtxtCode: TRichEdit;
    rtxtHintDemo: TRichEdit;
    lblStep5a: TLabel;
    procedure cmdNavNextClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cmdNavBackClick(Sender: TObject);
    procedure cmdNavCancelClick(Sender: TObject);
    procedure cmdNavFinishedClick(Sender: TObject);
    procedure OptTgt14Click(Sender: TObject);
    procedure optTgt16Click(Sender: TObject);
    procedure optTgtBothClick(Sender: TObject);
    procedure chkTypeConvOnClick(Sender: TObject);
    procedure cmdRemArgClick(Sender: TObject);
    procedure cmdPrevArgClick(Sender: TObject);
    procedure cmdNextArgClick(Sender: TObject);
    procedure cmdAddArgClick(Sender: TObject);
    procedure txtParamNameChange(Sender: TObject);
    procedure cmbDestVarNameChange(Sender: TObject);
    procedure chkArgOptionalClick(Sender: TObject);
    procedure cmdReloadClick(Sender: TObject);
    procedure cmdBrowseSavePathClick(Sender: TObject);
    procedure cmdShowLabelsClick(Sender: TObject);
    procedure cmdGetVars0Click(Sender: TObject);
    procedure cmdGetVars1Click(Sender: TObject);
    procedure cmbArgDataTypeChange(Sender: TObject);
    procedure cmdNavHelpClick(Sender: TObject);

  private
    { Private declarations }
    procedure ChangeStep(Sender:TObject);
    procedure PrepareNextPage(Sender: TObject);
    procedure UpDateMacroData(Sender:TObject);
    procedure ShowParam(Sender: TObject);
    procedure SetArgButtons(Sender: TObject);
    procedure SetChkOptionalEnabled(Sender: TObject);
    procedure ChkForAdd(Sender: TObject);
    procedure UpdateDataType(Sender:TObject);
    procedure AddRegisters(Control:TCombobox; Target: Integer);
    procedure AttributeCode(Sender: TOBject);
    function OnMessageHook(var Message : TMessage) : Boolean;
    function UpdateArg(Sender: TObject): Boolean;
    function GetItemIndex(Control: TComboBox; Index: Integer):Integer;
    function GetDataValue(Control: TComboBox; Index: Integer):Integer;
    function EvalStep(Sender: TObject):Boolean;

  Public
    { Public declarations }
  end;

var
  fmMacroGen: TfmMacroGen;
  Step: TList;
  CurrentStep: Integer;
  newTgt: Boolean;
  ParamNum: Integer;
  ParamCnt: Integer;
  TgtType: Integer;
  FirstOpt: Integer;
  FSize: Integer;
  FName: String;
  CommentColour: LongInt;
  CommentStyle: String;
  KeywordProtonColour: LongInt;
  KeywordProtonStyle: String;
  KeywordASMColour: LongInt;
  KeywordASMStyle: String;
  DeclareColour: LongInt;
  DeclareStyle: String;
  KeywordMacroParamColour: LongInt;
  KeywordMacroParamStyle: String;
  StringColour: LongInt;
  StringStyle: String;
  SFRColour: LongInt;
  SFRStyle: String;
  IdentifierColour: LongInt;
  IdentifierStyle: String;
  FilePath: String;
  lblsAvail: Boolean;

ResourceString
  Step0_rs = 'Step0';
  Step1_rs = 'Step1';
  Step2_rs = 'Step2';
  Step3_rs = 'Step3';
  Step4_rs = 'Step4';
  Step5_rs = 'Step5';
  Step6_re = 'Step6';

Const
  APP_CATEGORY = 'Software\JGBTools';
  APP_NAME = 'ProtonMacroGenerator';

function HtmlHelp(hwndCaller : HWND; pszFile: PChar; uCommand : Integer; dwData : DWORD) : HWND; stdcall; external 'hhctrl.ocx' name 'HtmlHelpA';

implementation

{$R *.dfm}


procedure TfmMacroGen.FormCreate(Sender: TObject);
Var
Index: Byte;
Registry: TRegistry;

begin
// Connect to IDE
   Application.HookMainWindow(OnMessageHook);
   plgConnect(Application.Handle);
   cmdShowLabels.Enabled := False;
   cmdGetVars0.Enabled := False;
   If plgIsConnected = true then
      begin
        pnlStat.Caption := 'IDE Connected';
        If GetSourceText then
          Begin
            cmdShowLabels.Enabled := GetLabels;
            cmdGetVars0.Enabled := GetVars;
            chkPasteCode.Enabled := True;
            Case GetSelectedIDECore of
            14:MacroInfo.Target := 1;
            16:MacroInfo.Target := 2;
            else
              MacroInfo.Target := 0;
             end;
          end;
        end
   Else
    Begin
      pnlStat.Caption := 'IDE Not Connected';
      chkPasteCode.Enabled := false;
      end;

   cmdGetVars1.Enabled := cmdGetVars0.Enabled;

// Set up all the initial values
    With cboReturn do
      Begin
        Clear;
        Items.Add('None');
        Items.Add('In-Line');
        Items.Add('Parameter');
        end;

// Create TList for all the Panels
  Step := TList.Create;
  Step.Add(pnlStep0);
  Step.Add(pnlStep1);
  Step.Add(pnlStep2);
  Step.Add(pnlStep3);
  Step.Add(pnlStep4);
  Step.Add(pnlStep5);
  Step.Add(pnlStep6);
  ChangeStep(Sender);

// Set the form title
  fmMacroGen.Caption := 'Proton Macro Generator';
// Position all the panels
  For Index := 0 to Step.Count -1 Do
    TPanel(Step.Items[Index]).Align := alTop;
    txtMacroName.Text := '';

// Pick up IDE settings or apply defaults ....
  Registry := TRegistry.Create(KEY_READ);
  Try
    Registry.RootKey := HKEY_CURRENT_USER;
    If Registry.OpenKey('MecaniqueUK\ProtonIDE\Options\Highlighter', False) = True then
      Begin
        FSize := Registry.ReadInteger('FontSize');
        FName := Registry.ReadString('FontName');
        CommentColour := Registry.ReadInteger('CommentColor');
        CommentStyle := Registry.ReadString('CommentStyle');
        KeywordProtonColour := Registry.ReadInteger('KeywordProtonColor');
        KeywordProtonStyle := Registry.ReadString('KeywordProtonStyle');
        KeywordASMColour := Registry.ReadInteger('KeywordASMColor');
        KeywordASMStyle := Registry.ReadString('KeywordASMStyle');
        DeclareColour := Registry.ReadInteger('DeclareColor');
        DeclareStyle := Registry.ReadString('DeclareStyle');
        KeywordMacroParamColour := Registry.ReadInteger('KeywordMacroParamColor');
        KeywordMacroParamStyle := Registry.ReadString('KeywordMacroParamStyle');
        StringColour := Registry.ReadInteger('StringColor');
        StringStyle := Registry.ReadString('StringStyle');
        SFRColour := Registry.ReadInteger('SFRColor');
        SFRStyle := Registry.ReadString('SFRStyle');
        IdentifierColour := Registry.ReadInteger('IdentifierColor');
        IdentifierStyle := Registry.ReadString('IdentifierStyle');
        end
      Else
        begin
          FSize := 8;
          FName := 'Courier New';
          CommentColour := $800000;
          CommentStyle := 'I';
          KeywordProtonColour := $0;
          KeywordProtonStyle := 'B';
          KeywordASMColour := $800000;
          KeywordASMStyle := 'B';
          DeclareColour := $80;
          DeclareStyle := 'B';
          KeywordMacroParamColour := $0;
          KeywordMacroParamStyle := 'B';
          StringColour := $8000;
          StringStyle := ' ';
          SFRColour := $8000;
          SFRStyle := ' ';
          IdentifierColour := $0;
          IdentifierStyle := ' ';
          end;
      Finally
        Registry.Free;
        inherited;
        end;

// Pick up Wizzards settings or apply defaults
   Registry := TRegistry.Create(KEY_READ);
   Try
     Registry.RootKey := HKEY_CURRENT_USER;
     If Registry.OpenKey(APP_CATEGORY + '\' + APP_NAME, False) = true then
      Begin
        FilePath := Registry.ReadString ('FilePath');
        chkPasteCode.Checked := Registry.ReadBool ('PasteMac');
        chkSaveCode.Checked := Registry.ReadBool ('SaveMac');
        chkSaveHint.Checked := Registry.ReadBool ('SaveHint');
        chkSaveSource.Checked := Registry.ReadBool ('SaveSource');
        chkTypeConvOn.Checked := Registry.ReadBool ('AllowTypeConv');
        cboReturn.ItemIndex := Registry.ReadInteger ('ReturnInd');
        chkNoCode.Checked := Registry.ReadBool ('NoCode');
        end
     Else
      Begin
        FilePath := 'C:\';
        chkPasteCode.Checked := False;
        chkSaveCode.Checked := False;
        chkSaveHint.Checked := False;
        chkSaveSource.Checked := False;
        chkTypeConvOn.Checked := False;
        cboReturn.ItemIndex := 0;
        chkNoCode.Checked := False;
        end
   Finally
    Registry.Free;
    inherited;
    end;

    ParamNum := 1;
    ParamCnt := 0;
    SetArgButtons (Sender);

// populate the instruction panels - can't understand how to read these form resource files.
    lblStep0.Caption := 'This Wizard will generate a Macro command for insertion in your Proton source code.' +#13#10#10
                      + 'You will be asked a series of questions about the parameters you wish to pass to the macro, the Data Type of each parameter and the internal variable into which you wish to place the parameter.' + #13#10#10
                      + 'When you have fininshed you can view the generated code before pasting it into your application';

    lblStep1.Caption := 'Enter the name you wish to call the Macro and a description of the Macro''s function.' + #13#10#10
                      + 'Choose the method of Return (if required).' + #13#10
                      + 'In-Line takes the form Var = Macro, Arg, Arg.' + #13#10
                      + 'Last Param places the return in the last parameter in the list.' + #13#10#10
                      + 'If you prefer to write your own code to be executed by the Macro tick "Build Skeleton"';

    lblStep2.Caption := 'Define the parameters passed to the Macro' + #13#10#10
                      + 'Press ADD to add additional parameters' + #13#10
                      + 'Press DELETE to remove parameter' + #13#10
                      + 'Press <<  >> to move between parameters' + #13#10#10
                      + 'Press NEXT when you have entered all parameters.';

    lblStep3.Caption := 'Enter the name of the routine the Macro will call.  It must be the name of an existing routine that is placed after the macro entry.' + #13#10#10
                      + 'Choose whether to Call or Jump to the routine by selecting Use GoSub or Use GoTo' + #13#10#10
                      + 'If there is a return parameter add Var name and type.';

    lblStep4.Caption :=  'You can review and edit the code generated';
    lblStep5a.Caption := 'For your hint popup to look like this....';
    lblStep5b.Caption := 'Add this to you USER.MCD file';
    lblStep6.Caption := 'Choose what you want to do with your macro.' + #13#10#10
                      + 'Checking "Paste Macro into IDE" will paste the code into the current IDE page at the current cursor position.' + #13#10#10
                      + 'Checking "Save" will store the selected file.' + #13#10
                      + 'Code will be saved as an RTF file and Hint will be saved as a text file.' + #13#10#10
                      + 'Saving the source will enable you to recall this macro with out re-entering all the parameters.';
end;
// Main Navigation .....
procedure TfmMacroGen.cmdNavNextClick(Sender: TObject);
begin
  If EvalStep (Sender) = True then  // Validate the step before moving to next
     begin
      UpDateMacroData(Sender);
      If CurrentStep < Step.Count Then
        Inc(CurrentStep);
        PrepareNextPage(Sender);
        ChangeStep (Sender);
        end;
end;

procedure TfmMacroGen.cmdNavBackClick(Sender: TObject);
begin
    If CurrentStep = 0 then
      CurrentStep := Step.Count -1
      Else
        Dec(CurrentStep);
    ChangeStep (Sender);
end;

//Shows new step
Procedure TfmMacroGen.ChangeStep(Sender:TObject);
Var
  Index: Integer;
  Item: TPanel;
Begin
  For index:= 0 to Step.Count -1 do
    Begin
      Item:= TPanel(Step.Items[Index]);
      If Index = CurrentStep then
        Item.Visible := True
        Else
          Item.Visible := False;
    End;
  If CurrentStep = 0 then
    cmdNavBack.Enabled := False
    Else
      Begin
      cmdNavBack.Enabled := True;
      cmdNavFinished.Enabled := False;
      End;
  If CurrentStep = Step.Count -1 then
      Begin
        cmdNavNext.Enabled := False;
        cmdNavFinished.Enabled := True;
        End
    Else
      Begin
        cmdNavNext.Enabled := True;
        cmdNavFinished.Enabled := False;
        End;
End;

procedure TfmMacroGen.cmdNavCancelClick(Sender: TObject);
begin
 Close;
end;

procedure TfmMacroGen.cmdNavFinishedClick(Sender: TObject);
Var
  Registry: TRegistry;
  Reply: Integer;
  s: String;
begin
    If chkPasteCode.Checked
    And plgIsConnected then       s := 'Code will be placed in ' + lblPasteDest.Caption
                                     + ' at your current cursor position.' + #13#10;
    If chkSaveCode.Checked then   s := s + 'Code will be saved to ' + lblSaveCodeName.Caption + #13#10;
    If chkSaveHint.Checked then   s := s + 'Hint will be saved to ' + lblSaveHintName.Caption + #13#10;
    If chkSaveSource.Checked then s := s + 'Source will be saved to ' + lblSaveSourceName.Caption + #13#10;
    If s = '' then
      s := 'Closing down Wizard - No action taken'
    Else
      s := s + #13#10 + 'Choose OK to continue with action' + #13#10 + 'or Cancel to return to Wizard';
    fmConfirm.ConfirmText := s;
    Reply :=  fmconfirm.ShowModal;
    If Reply = mrOK then
    begin
    // do the pasting and saving here.....
      If chkPasteCode.Checked
      And plgIsConnected then PasteTextAtCurrentPos(rtxtCode.text,GetCursorPos);
      // got to add the file saving bit....
      If chkSaveCode.Checked then begin
        s:= FilePath + '\' + lblSaveCodeName.Caption;
        If FileExists(s) then
          If MessageDlg('Overwrite existing file',mtWarning,[mbYes, mbNo],0) = mrYes then
            rtxtCode.Lines.SaveToFile(s)
          else
            Exit
        else
            rtxtCode.Lines.SaveToFile(s);
        end;

      If chkSaveHint.Checked then begin
        s:= FilePath + '\' + lblSaveHintName.Caption;
        If FileExists(s) then
          If MessageDlg('Overwrite existing file',mtWarning,[mbYes, mbNo],0) = mrYes then
            memoHint.Lines.SaveToFile(s)
          else
            Exit
        else
            memoHint.Lines.SaveToFile(s);
        end;

      If chkSaveSource.Checked then begin
        s := FilePath  + '\' + lblSaveSourceName.Caption;
        If FileExists(s) then
          If MessageDlg('Overwrite existing file',mtWarning,[mbYes, mbNo],0) = mrYes then
            WriteMacSource(s, ParamCnt)
          else
            Exit
        else
            WriteMacSource(s, ParamCnt);
        end;
      Registry := TRegistry.Create;
      Try
        Registry.RootKey := HKEY_CURRENT_USER;
        If Registry.OpenKey(APP_CATEGORY + '\' + APP_NAME , True) = True then // Create if doesn't exist
          Begin
            Registry.WriteString('FilePath', FilePath);
            Registry.WriteBool('PasteMac', chkPasteCode.Checked);
            Registry.WriteBool('SaveMac',chkSaveCode.Checked);
            Registry.WriteBool('SaveHint',chkSaveHint.Checked);
            Registry.WriteBool('SaveSource', chkSaveSource.Checked);
            Registry.WriteBool('AllowTypeConv',chkTypeConvOn.Checked);
            Registry.WriteInteger('ReturnInd', cboReturn.ItemIndex);
            Registry.WriteBool('NoCode',chkNoCode.Checked);
            end
      Finally
        Registry.Free;
        inherited;
      end;
  Close;
  end;
end;

// message hook - process messages in here...
function TfmMacroGen.OnMessageHook(var Message : TMessage) : Boolean;
begin 
   Result := False;
   if Message.Msg = WM_NOTIFY_PLUGIN then 
   begin 
      Result := true; 
      case Message.WParam of 
         NOTIFY_RELOAD_PLUGIN : begin end; 
         NOTIFY_TAB_CHANGED : begin end; 
         NOTIFY_EXPLORER_UPDATE : begin end; 
         NOTIFY_PRE_COMPILE : begin end; 
         NOTIFY_PRE_PROGRAM : begin end; 
         NOTIFY_COMPILE_SUCCESS : begin end; 
         NOTIFY_COMPILE_FAIL : begin end; 
         NOTIFY_DEVICE_CHANGED : begin end; 
         NOTIFY_OSC_CHANGED : begin end;
         NOTIFY_SELECTION_CHANGED : begin end; 
         NOTIFY_PROGRAMMER_CHANGED : begin end; 
         NOTIFY_PROGRAMMER_INSTALLED : begin end; 
         NOTIFY_PROGRAMMER_DELETED : begin end; 
         NOTIFY_VERSION : begin end; 
      end; 
   end; 
end;

procedure TfmMacroGen.FormDestroy(Sender: TObject);
Var
Index : Byte;

begin    // free up all objects and disconnect from IDE.
  For Index := 0 to Step.Count -1 do
    TPanel(Step.Items[index]).Free;
  Step.Free;
  Application.UnhookMainWindow(OnMessageHook);
end;

Function TfmMacroGen.EvalStep(Sender: TObject):Boolean;
Var
  MessageStr: String;
  EvalOK: Boolean;

begin
  Case CurrentStep of
  1: Begin
      EvalOK := CheckName(txtMacroName.Text);
      MessageStr := 'You must enter a valid name for your macro to continue';
      end;

  2: Begin
      If (ParamNum <= ParamCnt)
      And (UpdateArg(Sender)) = True then
          begin
            EvalOK := CheckParamSet;
            MessageStr := 'Incomplete Parameter Set';
            end
      Else
        EvalOK := True;
      end;
  3: Begin
      EvalOK := CheckName(cmbSubroutineName.Text) ;
      MessageStr := 'Subroutine Name or Return Varaiable contains invalid characters';
      If (MacroInfo.RtnMethod > 0)
      And EvalOK  then
        begin
          EvalOk  := CheckName(cmbRetVarName.Text);
          MessageStr:= 'Return Variable contains invalid characters';
          end;
      end;
  Else
    EvalOK := True;
  end;
  If EvalOK = False then
    MessageDlg(MessageStr, mtInformation, [mbOK],0);

  EvalStep := EvalOK;
end;

Procedure tfmMacroGen.PrepareNextPage(Sender: TObject);
// Sets up the controls for the next Step according to settings made on previous Steps
Var
s: String;

Begin
  Case CurrentStep Of
  1: begin
      txtMacroName.Text := MacroInfo.MacroName;
      memoDescription.Text := MacroInfo.Descr;
      case MacroInfo.Target of
      0: optTgtBoth.Checked := true;
      1: optTgt14.Checked := True;
      2: optTgt16.Checked := True;
      end;
      chkNoCode.Checked := MacroInfo.NoCode;
      cboReturn.ItemIndex := MacroInfo.RtnMethod;
      Newtgt := True;
      end;
  2: begin    // Set up Page to collect arguments....
      pnlDestVar.Visible := Not chkNoCode.Checked;
      If newTgt = True then // Target PIC changed so reset the Var name & data types
        AddRegisters(cmbDestVarName, MacroInfo.Target);
        AddRegisters(cmbRetVarName, MacroInfo.Target);
      UpdateDataType(Sender);
      If ParamCnt > 0 then
        ShowParam(Sender)
        Else
        begin
          txtParamName.Text := '';
          cmbDestVarName.Text := '';
          cmbArgDataType.ItemIndex := 0;
          end;
      end;
  3: begin   // Set up page to collect Subroutine call and return data ....
      Str(ParamCnt, s);
      lblParamNums.Caption := 'You have entered ' + s + ' parameters';
      If MacroInfo.RtnMethod > 0 then
        begin
          pnlReturnVar.Visible := True;
          optJumpSub.Enabled := False;
          optCallSub.Checked := True;
          end
        Else
          begin
            pnlReturnVar.Visible := False;
            optJumpSub.Enabled := True;
            If ReturnData.SRName > '' then
              begin
                optJumpSub.Checked := ReturnData.JumpType;
                optCallSub.Checked := ReturnData.CallType;
                end
            Else
              OptCallSub.Checked := True;
            end;
      cmbSubroutineName.text := ReturnData.SRName;
      cmbRetVarName.Text := ReturnData.RetVar.ArgName;
      If ReturnData.RetVar.ArgType > 0 then
        cmbRetDataType.ItemIndex := GetItemIndex(cmbRetDataType,ReturnData.RetVar.ArgType)
        else
        cmbRetDataType.ItemIndex := 0;
      chkRetOptional.Checked := ReturnData.RetVar.ArgOpt;
      chkAllowAltRet.Checked := ReturnData.RetVar.ArgAlt;
      end;

  4: Begin
      rtxtCode.Font.Name := FName;
      rtxtCode.Font.Size := FSize;
      rtxtCode.Lines := GetMacroCodeRtf(ParamCnt);
      AttributeCode(Sender);
      end;

  5: Begin
      memoHint.Lines := GetHintStr(ParamCnt);
      s := GetHintRTF;
      rtxtHintDemo.Text := s;//GetHintRTF;
      end;

  6: begin
      lblPasteDest.Caption := GetSelectedIDEName;
      lblSaveCodeName.Caption := MacroInfo.MacroName + '_mac.rtf';
      lblSaveHintName.Caption := MacroInfo.MacroName + '_hnt.dat';
      lblSaveSourceName.Caption := MacroInfo.MacroName + '.mcs';
      txtSavePath.Text := FilePath;
    end;

  end;
end;

Procedure tfmMacroGen.UpdateDataType(Sender:TObject);
// Populates the Data Type Combos according to the current PIC type and adds the
// the Parameter Type number into the pointer.
Var
  j: Integer;
  s: String;
  s1: String;

Begin
    cmbArgDataType.Clear;
    cmbRetDataType.Clear;
    For j := 0 to 30  Do
      begin
      s := StrDataType(j, tgtType).UIName;
          s1 := LeftStr(s, Pos('|', s)-1);
          If s1 <> 'N/A' then cmbArgDataType.Items.AddObject(s1, pointer(j));
          s1 := RightStr(s,Length(s) - Pos('|',s));
          If s1 <> 'N/A' then cmbRetDataType.Items.AddObject(s1, Pointer(j));
      end;
      cmbArgDataType.ItemIndex := 0;
      cmbRetDataType.ItemIndex := 0;
end;

procedure TfmMacroGen.OptTgt14Click(Sender: TObject);
begin
  NewTgt := True;
  tgtType := 1;
end;

procedure TfmMacroGen.optTgt16Click(Sender: TObject);
begin
  NewTgt := True;
  tgtType := 2;
end;

procedure TfmMacroGen.optTgtBothClick(Sender: TObject);
begin
  NewTgt := True;
  tgtType := 0;
end;

Procedure TfmMacroGen.UpDateMacroData(Sender:TObject);
begin
  Case CurrentStep of
  1: begin // Save the Parameters set up in Step 1
     with MacroInfo do
        begin
          MacroName := txtMacroName.Text;
          RtnMethod := cboReturn.ItemIndex;
          Target := tgtType;
          NoCode := chkNoCode.Checked;
          Descr := memoDescription.text;
          end;
        end;
  2: MacroInfo.ParamCnt := ParamCnt; // Add in the parameter count to Step 1 record
                                     // Step 2 Args already held in Arguments array.
  3: begin  // Save the Subroutine and Return Variable info.
        With ReturnData Do
          begin
            SRName := cmbSubroutineName.Text;
            CallType := optCallSub.checked;
            JumpType := optJumpSub.checked;
            RetVar.ArgVar := cmbRetVarName.Text;
            RetVar.ArgType := integer(cmbRetDataType.Items.Objects[cmbRetDataType.ItemIndex]);
            RetVar.ArgOpt := chkRetOptional.Checked;
            RetVar.ArgAlt := chkAllowAltRet.Checked;
            end;
          end;
  Else

  end;
end;

procedure TfmMacroGen.chkTypeConvOnClick(Sender: TObject);
begin
    If chkTypeConvOn.State = cbChecked Then
      begin
       chkAllowAltArgs.Visible := False;
       chkAllowAltArgs.State := cbChecked;
       chkAllowAltRet.Visible := False;
       chkAllowAltRet.State := cbChecked;
       end
    Else
      begin
       chkAllowAltArgs.Visible := True;
       chkAllowAltArgs.State := cbUnChecked;
       chkAllowAltRet.Visible := True;
       chkAllowAltRet.State := cbUnChecked;
       End
end;

// Add, Remove and Navigate the Macro arguments
procedure TfmMacroGen.cmdAddArgClick(Sender: TObject);
begin
  If UpdateArg(Sender) = True Then
    Begin
    txtParamName.Text := '';
    txtParamName.SetFocus;
    cmbDestVarName.Text := '';
    cmbArgDataType.ItemIndex := 0;
    If ParamNum < 20 then
      begin
        Inc(ParamNum);
        Inc(ParamCnt);
        SetArgButtons (Sender);
        end;
    SetChkOptionalEnabled (Sender);
    end;
end;

procedure TfmMacroGen.cmdRemArgClick(Sender: TObject);
Var i: Integer;

begin
  If ParamNum <= ParamCnt then
    begin
      MessageBeep (MB_ICONASTERISK);
      If MessageDlg ('Are you sure you want to delete' + #10 + #13+ txtParamName.Text + '?',
                      mtConfirmation, [mbYes, mbNo],0) = mrYes then
        Begin
          For i := ParamNum to ParamCnt Do
            Arguments[i] := Arguments[i+1];
            ShowParam (Sender);
            Dec(ParamCnt);
            SetArgButtons (Sender);
            end;
        end;
end;

procedure TfmMacroGen.cmdPrevArgClick(Sender: TObject);
begin
  If (ParamNum > 1) Then
    If (ParamNum <= ParamCnt)           // If parameter could have been changed
    And (UpdateArg(Sender) = True)      // Update the arguments and Don't step back unless OK
    OR (ParamNum > ParamCnt) then
      begin
        Dec(ParamNum);
        SetArgButtons (Sender);
        ShowParam (Sender);
        end;
end;

procedure TfmMacroGen.cmdNextArgClick(Sender: TObject);
begin
If ParamNum <= ParamCnt then
  begin
    If UpdateArg(Sender) = True then
      begin
        Inc(ParamNum);
        SetArgButtons(Sender);
        ShowParam (Sender);
        end;
  end;
end;


Procedure TFmMacroGen.SetArgButtons(Sender:TObject);
//Sets the enabled stste of the Argument navigation buttons
Var
  s: String;
Begin
  cmdAddArg.Enabled := False;   // Always clear Add until a new parameter has been entered
  If ParamCnt = 0 then          //No Arguments entered
    Begin
      cmdPrevArg.Enabled := False;
      cmdNextArg.Enabled := False;
      cmdRemArg.Enabled := False;
      end
  Else
    If ParamNum = 1 then    // Just 1 argument entered
      begin
        cmdPrevArg.Enabled := False;
        cmdNextArg.Enabled := True;
        cmdRemArg.Enabled := True;
        end
    Else
      If ParamNum = ParamCnt +1 then  // Reach end of List - enter new param
        Begin
          cmdPrevArg.Enabled := True;
          cmdNextArg.Enabled := False;
          cmdRemArg.Enabled := False;
          end
        Else
          Begin                         // Mid List so all buttons are on
            cmdPrevArg.Enabled := True;
            cmdNextArg.Enabled := True;
            cmdRemArg.Enabled := True;
            end;
//Report the current Parameter number or "Enter New Param"
  With pnlParamNum Do
  If (ParamNum > ParamCnt)
  And (ParamNum < 20) then
    Caption := 'Enter New Param'
    Else
      begin
        If ParamNum = 20 then
          Caption := 'Param Count Exceeded'
        else
          begin
            Str(paramNum, s);
            Caption := 'Parameter ' + s;
            end;
        end;
end;

Procedure tfmMacroGen.ShowParam(Sender: TObject);
// Display the parameters storing in the Arguments array.
begin
  If ParamCnt > 0 then
    begin
      With Arguments[ParamNum] do
        Begin
          txtParamName.Text := ArgName;
          cmbDestVarName.Text := ArgVar;
          cmbArgDataType.ItemIndex := GetItemIndex(cmbArgDataType, ArgType);
          chkArgOptional.Checked := ArgOpt;
          chkAllowAltArgs.Checked := ArgAlt;
          SetChkOptionalEnabled(Sender);
          end;
    end;
end;

Function tfmMacroGen.UpdateArg(Sender: TObject): Boolean;
Begin
  If EvaluateParams(txtParamName.Text, cmbDestVarName.Text, MacroInfo.NoCode) Then
    begin
      With Arguments[ParamNum] do
        begin
          ArgName := txtParamName.Text;
          ArgType := GetDataValue(cmbArgDataType, cmbArgDataType.ItemIndex);
          ArgVar := cmbDestVarName.Text;
          If chkArgOptional.Checked = True Then
            begin
              ArgOpt := True;
              If FirstOpt = 0 Then FirstOpt := ParamNum;
              end
          Else
            ArgOpt := False;

          ArgAlt := chkAllowAltArgs.Checked;
          UpdateArg := True;
        end;
      end
Else
  Begin
     MessageBeep (MB_ICONASTERISK);
     MessageDlg ('You have entered invalid characters'+ #10 + #13
             + 'in the Parameter or Variable Name', mtInformation, [mbOK],0);
     UpdateArg := False;
     end;
end;

Procedure TfmMacroGen.SetChkOptionalEnabled(Sender: TObject);
begin
    If (FirstOpt > 0) And (ParamNum > FirstOpt) Then
        chkArgOptional.Enabled := False
    Else
        chkArgOptional.Enabled := True;
end;

procedure TfmMacroGen.txtParamNameChange(Sender: TObject);
begin
  chkForAdd(Sender);  // enable the Add button if all fields are completed
end;

procedure TfmMacroGen.cmbDestVarNameChange(Sender: TObject);
begin
  ChkForAdd(Sender); // enable the Add button if all fields are completed
end;

procedure TfmMacroGen.cmbArgDataTypeChange(Sender: TObject);
begin
  ChkforAdd(Sender); // enable the Add button if all fields are completed
end;

Procedure tfmMacroGen.ChkForAdd(Sender: TObject);
// Checks that conditions are right to enable tha ADD button - and enables it.
begin
  If  (txtParamName.Text > '')
  And (ParamNum = ParamCnt + 1)
  And (MacroInfo.NoCode = False)
  And (cmbDestVarName.Text > '')
  And (cmbArgDataType.ItemIndex <> -1)
  And (ParamNum < 20) Then
      cmdAddArg.Enabled := True;
end;

Function tfmMacroGen.GetItemIndex(Control: TComboBox; Index: Integer):Integer;
//Returns the ItemIndex of the item whose Pointer value is = to Index.
Var
  i, j: Integer;
Begin
  GetItemIndex := -1;
//  With Control Do
    For i := 0 to Control.Items.Count -1 Do
      Begin
        j := integer(Control.Items.Objects[i]);
        If  j = Index then
          Begin
            GetItemIndex := i;
            Break;
            end;
          end;
end;

Function tfmMacroGen.GetDataValue(Control: TComboBox; Index: Integer):Integer;
//Returns the Pointer value at the ItemIndex held in Index
begin
  If Index <= Control.Items.Count then
    GetDataValue := Integer(Control.Items.Objects[Index])
    Else
    GetDataValue := -1;
end;

procedure TfmMacroGen.chkArgOptionalClick(Sender: TObject);
// Only optional parameters can appear after the first optional parameter
Var
i: Integer;

begin
// Check to see if the optional state has been changed, update state in Arguments and first opt
    With Arguments[ParamNum]do
        If (chkArgOptional.Checked = False) And (ArgOpt = True) Then
          Begin
            ArgOpt := False;
            FirstOpt := ParamNum + 1;
            chkRetOptional.Enabled := True; // Can only have optional Args OR optional Return
            end
        Else
          begin
          If (chkArgOptional.Checked = True) And (ArgOpt = False) Then
            begin
              ArgOpt := True;
              FirstOpt := ParamNum;
              end;
            end;
// Run through whole array and update the option values
    For i := 1 To ParamCnt do
      begin
        With Arguments[i] do
            If i < FirstOpt Then
                ArgOpt := False
            Else
                ArgOpt := True;
          end;
end;

procedure TfmMacroGen.cmdReloadClick(Sender: TObject);

Begin
  OpenDialog1.InitialDir := FilePath;
  if OpenDialog1.Execute then                   // Let User Choose file
  begin
    ParamCnt := ReadMacSource(OpenDialog1.FileName);
    If paramCnt > 0 then      // If we have loaded new arguments
      begin
      ParamNum := 1;          // set argument pointer to first argument
      SetArgButtons(Sender);
      end;
    PrepareNextPage(Sender);  // Now update the page.
  end;
end;

// Set up the Browse Save Path Dialog
procedure TfmMacroGen.cmdBrowseSavePathClick(Sender: TObject);
begin
 BrowseForFolder1.Path := FilePath;
  If BrowseForFolder1.Execute then
    begin
      FilePath:= BrowseForFolder1.Path;
      txtSavePath.Text := Filepath;
      end;
end;

procedure TfmMacroGen.cmdShowLabelsClick(Sender: TObject);
begin
  cmbSubroutineName.Clear;
  cmbSubroutineName.Items := Labels;
  cmbSubroutineName.ItemIndex := 0;
  cmbSubroutineName.Sorted := True;
  cmdShowLabels.Enabled := False;
end;

procedure TfmMacroGen.cmdGetVars0Click(Sender: TObject);
begin
  cmbDestVarname.Clear;
  cmbDestVarName.Items := Vars;
  cmbDestVarName.ItemIndex := 0;
  AddRegisters(cmbDestVarName,MacroInfo.Target);
  cmbDestVarName.Sorted := True;
  cmdGetVars0.Enabled := False;
end;

procedure TfmMacroGen.cmdGetVars1Click(Sender: TObject);
begin
  cmbRetVarName.Clear;
  cmbRetVarName.Items := Vars;
  cmbRetVarName.ItemIndex := 0;
  AddRegisters(cmbRetVarName, MacroInfo.Target);
  cmbRetVarName.Sorted := True;
  cmdGetVars1.Enabled := False;
end;

Procedure tfmMacroGen.AddRegisters(Control:TCombobox; Target: Integer);
Begin
  Case Target of
  1: Control.Items.Add ('FSR');
  2: Begin
      Control.Items.Add('FSR0');
      Control.Items.Add('FSR1');
      Control.Items.Add('FSR2');
      end;
  end;
end;

Procedure TfmMacroGen.AttributeCode(Sender: TObject);
Var
  Pos: LongInt;

  Procedure SetStyle (AColour: Integer; AStyle: String);
  Begin
    With rtxtCode.SelAttributes Do Begin
      Color := AColour;
      if AnsiContainsText(AStyle, 'I') then
        if AnsiContainsText(AStyle, 'B') then
          Style := [fsItalic, fsBold]
        else
          Style := [fsItalic]
      else
        if AnsiContainsText(AStyle, 'B') then
          Style := [fsBold]
        else
          Style := [];
          end;
    end;

  Procedure SetAttributes(search: string; AColour: Integer; AStyle: String);
  Var
    ToEnd: LongInt;
// sets the font attributes for the Search string in the RTF text box.
  begin
    With rtxtCode Do begin
      Pos := 0;
      Repeat begin
        ToEnd := Length(Text) - Pos;
        Pos := FindText(Search, Pos, ToEnd,[stWholeWord]);
        SelStart := Pos;
        SelLength := Length(Search);
        If Pos <> -1 then begin
          SetStyle (AColour, AStyle);
          Pos := Pos + Length(SelText);
          end;
        end;
        Until Pos = -1;
      end;
    end;

  Procedure SetStringAttrib(StrStart, StrEnd: String; AColour: Integer; AStyle: String);
  Var
    ToEnd: LongInt;
    EndPos: LongInt;

  Begin
     With rtxtCode Do begin
      Pos := 0;
      Repeat begin
        ToEnd := Length(Text) - Pos;
        Pos := FindText(StrStart, Pos, ToEnd,[]);
        SelStart := Pos;
        If Pos <> -1 then begin
          EndPos := FindText(StrEnd, Pos + 1, ToEnd,[]);
          If EndPos <> - 1 then begin
            rtxtcode.SelLength := EndPos - Pos + 1;
            SetStyle (AColour, AStyle);
            Pos := Pos + Length(SelText) + 1;
            end
          else
            Break;
            end
        else
          Break;
          end;
      Until Pos = -1;
      end;
  end;

Begin
// Set up Default Attributes
    rtxtCode.DefAttributes.Name := FName;
    rtxtCode.DefAttributes.Color := $0;
    rtxtCode.DefAttributes.Size := FSize;
    rtxtCode.DefAttributes.Style := [];
// Set Declare Style
    SetAttributes ('MACRO', DeclareColour, DeclareStyle);
    SetAttributes ('#IF', DeclareColour, DeclareStyle);
    SetAttributes ('#ELSE', DeclareColour, DeclareStyle);
    SetAttributes ('#ENDIF', DeclareColour, DeclareStyle);
    SetAttributes ('ENDM', DeclareColour, DeclareStyle);
    SetAttributes ('#ERROR', DeclareColour, DeclareStyle);
// Set SFR Style
    SetAttributes ('FSR', SFRColour, SFRStyle);
    SetAttributes ('FSR0L', SFRColour, SFRStyle);
    SetAttributes ('FSR1L', SFRColour, SFRStyle);
    SetAttributes ('FSR2L', SFRColour, SFRStyle);
// Set String Style
    SetStringAttrib ('"', '"', StringColour, StringStyle);
// Set Keyword Style
    SetAttributes ('GoTo', KeywordProtonColour, KeywordProtonStyle);
    SetAttributes ('GoSub', KeywordProtonColour, KeywordProtonStyle);
//Set Comment Style
    SetStringAttrib ('''', #13#10, CommentColour, CommentStyle);
// Return carret to start
    rtxtCode.SelStart := 0;
end;

procedure TfmMacroGen.cmdNavHelpClick(Sender: TObject);
Var
ContextID: DWord;
Const
HH_HELP_CONTEXT = $F;

begin
  ContextID := 1000 + 10 * (CurrentStep + 1);
  HTMLHelp(Application.Handle,'ProtonMacroGen.chm',HH_HELP_CONTEXT, ContextID);
end;

End.


