unit cPluginInterface; 

interface 

uses 
   Windows, Messages, cPluginTypes; 


const 
   // the plugin manager DLL name... 
   DLL_NAME = 'mcPluginMgr.dll'; 

// DLL interface functions... 
function plgConnect(pHostWin:HWND):BOOL;stdcall;external DLL_NAME name 'Connect'; 
function plgDisconnect:BOOL;stdcall;external DLL_NAME name 'Disconnect'; 
function plgIsConnected:BOOL;stdcall;external DLL_NAME name 'IsConnected'; 
procedure plgGetPathIDE(pPath:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPathIDE'; 
procedure plgGetPathCompiler(pPath:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPathCompiler'; 
procedure plgGetPathPlugin(pPath:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPathPlugin'; 
procedure plgGetPage(pFilename:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPage'; 
function plgGetPageInfo(pFilename:LPSTR;pInfo:LPPAGEINFO):BOOL;stdcall; external DLL_NAME name 'GetPageInfo'; 
function plgSetPage(pFilename:LPSTR):BOOL;stdcall; external DLL_NAME name 'SetPage'; 
function plgGetPageByIndex(pIndex:UINT;pFilename:LPSTR;pLen:UINT):BOOL;stdcall; external DLL_NAME name 'GetPageByIndex'; 
function plgGetPageCount:UINT;stdcall;external DLL_NAME name 'GetPageCount'; 
function plgGetPageIncludeByIndex(pFilename:LPSTR;pIndex:UINT;pInclude:LPSTR;pLen:UINT):BOOL;stdcall; external DLL_NAME name 'GetPageIncludeByIndex'; 
function plgGetPageIncludeCount(pFilename:LPSTR):UINT;stdcall;external DLL_NAME name 'GetPageIncludeCount'; 
procedure plgSetPageNew(pFilename:LPSTR);stdcall; external DLL_NAME name 'SetPageNew'; 
procedure plgSetPageClear;stdcall; external DLL_NAME name 'SetPageClear'; 
procedure plgSetPageInsertHeader;stdcall; external DLL_NAME name 'SetPageInsertHeader'; 
procedure plgGetPageText(pText:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPageText'; 
procedure plgGetPageTextRTF(pText:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPageTextRTF'; 
procedure plgGetPageSelectedText(pText:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetPageSelectedText'; 
procedure plgSetPageUpdateText(pText:LPSTR;pSaveUpdate:BOOL);stdcall; external DLL_NAME name 'SetPageUpdateText'; 
procedure plgSetPageText(pText:LPSTR);stdcall; external DLL_NAME name 'SetPageText'; 
procedure plgSetPageTextAt(pX,pY:UINT;pText:LPSTR);stdcall; external DLL_NAME name 'SetPageTextAt'; 
procedure plgSetPageSelectTextAt(pSelStart,pSelLength:UINT);stdcall; external DLL_NAME name 'SetPageSelectTextAt'; 
procedure plgSetPageCursorPos(pX,pY:UINT);stdcall; external DLL_NAME name 'SetPageCursorPos'; 
procedure plgGetPageCursorPos(var pX:UINT;var pY:UINT);stdcall; external DLL_NAME name 'GetPageCursorPos'; 
procedure plgSetPageTopLine(pLineNumber:UINT);stdcall; external DLL_NAME name 'SetPageTopLine'; 
procedure plgGetPageDisplayLines(var pTopLine:UINT;var pLinesInWindow:UINT);stdcall; external DLL_NAME name 'GetPageDisplayLines'; 
procedure plgSetPageSave; stdcall;external DLL_NAME name 'SetPageSave'; 
procedure plgSetPageLoad(pFilename:LPSTR); stdcall;external DLL_NAME name 'SetPageLoad'; 
procedure plgSetPageVersion(pFilename:LPSTR;pMajor,pMinor,pRelease,pBuild:BYTE); stdcall;external DLL_NAME name 'SetPageVersion'; 
procedure plgSetPageVersionEnabled(pFilename:LPSTR;pValue:BOOL);stdcall;external DLL_NAME name 'SetPageVersionEnabled'; 
procedure plgSetPageLineColor(pLineNumber,pBG,pFG:UINT);stdcall;external DLL_NAME name 'SetPageLineColor'; 
procedure plgSetPageLineColorDelete(pLineNumber:UINT);stdcall;external DLL_NAME name 'SetPageLineColorDelete'; 
procedure plgSetPageLineColorClear;stdcall;external DLL_NAME name 'SetPageLineColorClear'; 
function plgIsProgrammerAvailable:BOOL;stdcall;external DLL_NAME name 'IsProgrammerAvailable'; 
procedure plgGetProgrammer(pName:LPSTR;pLen:UINT);stdcall; external DLL_NAME name 'GetProgrammer'; 
function plgGetProgrammerInfo(pName:LPSTR;pInfo:LPPROGINFO):BOOL;stdcall; external DLL_NAME name 'GetProgrammerInfo'; 
function plgSetProgrammer(pName:LPSTR):BOOL;stdcall; external DLL_NAME name 'SetProgrammer'; 
function plgGetProgrammerByIndex(pIndex:UINT;pName:LPSTR;pLen:UINT):BOOL;stdcall; external DLL_NAME name 'GetProgrammerByIndex'; 
function plgGetProgrammerCount:UINT;stdcall;external DLL_NAME name 'GetProgrammerCount'; 
function plgExecuteCompile:BOOL;stdcall; external DLL_NAME name 'ExecuteCompile'; 
procedure plgExecuteCompileAsync;stdcall; external DLL_NAME name 'ExecuteCompileAsync'; 
procedure plgExecuteProgram;stdcall; external DLL_NAME name 'ExecuteProgram'; 
procedure plgSetLoadFromFile(pFilename:LPSTR); stdcall;external DLL_NAME name 'SetLoadFromFile'; 
procedure plgSetForegroundWindow;stdcall; external DLL_NAME name 'SetForegroundWindow';  

implementation 

end.

